1.2 Udforskning af brugerfladen

# Sonic Pi-brugerfladen

Sonic Pi har en meget simpel brugerflade til at kode musik. Lad os tage et kig på den.

![Sonic Pi-brugerfladen](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Afspilning
* *B* - Styring af kodefelt
* *C* - Information og hjælp
* *D* - Kodefelt
* *E* - Indstillinger
* *F* - Logfremviser
* *G* - Hjælpesystem
* *H* - Oscilloskop
* *F* -In/ud Punkt viser

## A. Afspilning

Disse lyserøde knapper bruger du til at starte og stoppe lydene. Der er *Run*-knappen til at køre koden i kodefeltet, *Stop* til at stoppe al kørende kode, *Save* til at gemme koden til en ekstern fil og *Record* til at lave en optagelse (en WAV-fil) af den lyd der bliver afspillet.

## B. Styring af kodefelt

Disse orange knapper giver mulighed for at ændre kodefeltet. Knapperne *Size +* og *Size -* giver dig mulighed for at gøre teksten større og mindre.

## C. Information og hjælp

Disse blå knapper giver adgang til information, hjælp og indstillinger. *Info*-knappen vil åbne informationsvinduet som giver information om selve Sonic Pi - kerne-udviklerholdet, historien, bidragsydere og fællesskabet. *Help*-knappen viser og skjuler hjælpesystemet (*G*), og *Prefs*-knappen viser og skjuler indstillingsvinduet som giver mulighed for at styre nogle grundlæggende systemindstillinger.

## D. Kodefelt

Dette er stedet hvor du skriver din kode og komponerer/opfører din musik. Det er et simpelt tekst-redigeringsfelt hvor du kan skrive kode, slette det, klippe og kopiere osv. Tænk på det som en meget simpel udgave af Word eller Google Docs. Redigeringsfeltet vil automatisk farve ord på baggrund af deres betydning i koden. Det virker måske mærkeligt i starten, men du vil snart finde det meget nyttigt. For eksempel vil du vide at noget er et tal fordi det er blåt.

## E. Indstillinger

Sonic Pi stiller en række instillinger til rådighed som kan tilgås via *Prefs*-knappen i området Information og hjælp. Den vil vise eller skjule indstillingspanelet som indeholder et antal indstillinger som kan ændres. For eksempel kan du gennemtvinge mono-tilstand, bytte rundt på stereo, og vælge hvad der skal i loggen. Der er også styring af lydstyrken og en lydvælger på Raspberry Pi.

## F. Logfremviser

Når du kører din kode, vil information om hvad programmet laver, blive vist i logfremviseren. Som udgangspunkt vil du se en besked for hver lyd du spiller med det præcise tidspunkt lyden blev startet på. Det er meget nyttigt til fejlfinding i din kode og til at forstå hvad din kode faktisk gør.

## G. Hjælpesystem

En af de vigtigste dele af brugerfladen i Sonic Pi er hjælpesystemet som bliver vist i bunden af vinduet. Det kan vises eller skjules ved at trykke på den blå *Help*-knap. Hjælpesystemet indeholder hjælp og information om alle dele af Sonic Pi, bl.a. denne vejledning, en liste af tilgængelige synths, lydklip, eksempler, effekter og en komplet liste af alle funktionerne som Sonic Pi stiller til rådighed for at kode musik.

## H. Oscilloskop

Oscilloskopet viser den lyd du hører. Her kan du se at en `saw`-synth ligner en sav, og at det grundlæggende bip er en sinusbølge. Du kan også se forskellen mellem larmende og stille lyde fra størrelsen af linjerne. Der er tre oscilloskoper at lege med. Standard-oscilloskopet viser venstre og højre lydudgange kombineret. Der er også en stereo-visning som tegner separate oscilloskoper for hver kanal. Endelig er der et Lissajous-kurve-skop som viser fase-afhængighederne mellem venstre og højre kanal og giver mulighed for at tegne flotte billeder med lyd (https://en.wikipedia.org/wiki/Lissajous_curve).

## F. Logfremviser

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
