2.2 Synth-parametre

# Synth-parametre: Amplitude og panorering

Ligesom du kan styre hvilken tone du spiller eller hvilket lydklip du starter, stiller Sonic Pi en række parametre til rådighed for at udforme og styre lydene. Vi kommer til at dække mange af disse i denne vejledning, og der er udførlig dokumentation for alle parametrene i hjælpesystemet. Indtil videre vil vi dog nøjes med at præsentere to af de mest brugbare: *amplitude* (lydstyrke) og *panorering* (bevægelse mellem stereo-højttalerne).


## Parametre

Sonic Pi giver mulighed for at sætte parametre når du afspiller synths. Du styrer parametrene ved at give dem med til `play`, og du kan på den måde styre lyden. Hver synth har sine egne parametre for at ændre dens lyd. Der er dog nogle parametre der går igen på tværs af mange lyde, fx `amp:` (til amplitude) og envelope-muligheder (kontur af lyden - det dækker vi i et andet kapitel).

Når du sætter parametre, skal du angive to dele: deres navn og deres værdi. For eksempel kan du have en parameter der hedder `cheese:`, som du ønsker at sætte til værdien `1`.

Parametre gives til kald til `play` ved at bruge et komma (`,`), navnet på parameteren såsom `amp:` (glem ikke kolonet, `:`) og til sidste et mellemrum og værdien for parameteren. For eksempel:

```
play 50, cheese: 1
```

(For god ordens skyld: `cheese` er ikke en rigtig parameter; vi bruger den blot som et eksempel.)

Du kan sætte flere parametre ved at adskille dem med komma:

```
play 50, cheese: 1, beans: 0.5
```

Rækkefølgen af parametre er ligegyldig, så nedenstående gør det samme:

```
play 50, beans: 0.5, cheese: 1
```

Parametre som ikke kan sættes på synth'en, ignoreres blot, såsom `cheese` og `beans` som er åbenlyst fjollede parameternavne!

Hvis du ved et uheld sætter samme parameter to gange med forskellige værdier, bruges den sidste. For eksempel vil `beans` her få værdien 2, ikke 0.5:

```
play 50, beans: 0.5, cheese: 3, eggs: 0.1, beans: 2
```

Mange ting i Sonic Pi kan tage parametre, så brug lidt tid på at lære hvordan du bruger dem. Lad os lege med vores første parameter: `amp:`.

## Amplitude

Amplitude er en computers repræsentation af lydniveauet. En *høj amplitude giver en kraftig lyd*, og en *lav amplitude giver en stille lyd*. Ligesom Sonic Pi bruger tal til at repræsentere tid og toner, bruger den tal til at repræsentere amplitude. En amplitude på 0 er helt stille (du vil ikke høre noget), hvorimod en amplitude på 1 svarer til normalt lydniveau. Du kan endda skrue amplituden højere - på 2, 10, 100... Du skal dog være opmærksom på at når den samlede amplitude af alle lydene bliver for høj, bruger Sonic Pi hvad der kaldes en kompressor til at komprimere lydene sådan at de ikke bliver for høje for dine ører. Det kan gøre lyden mudret og mærkelig. Så prøv at bruge lave amplituder, dvs. i området fra 0 til 0.5, for at undgå komprimering.


## Skru det op

For at ændre amplituden af en lyd kan du bruge parameteren `amp:`. Du kan fx spille med halv amplitude ved at bruge 0.5:

```
play 60, amp: 0.5
```

Du kan spille med dobbelt amplitude ved at bruge 2:

```
play 60, amp: 2
```

Parameteren `amp:` ændrer kun det kald til `play` som den bruges på. I dette eksempel vil det første kald til `play` blive spillet på halvt niveau, mens det andet kald vil gå tilbage til udgangspunktet (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Du kan selvfølgelig bruge forskellige værdier for `amp:` ved hvert kald til `play`:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Panorering

En anden sjov parameter at pille ved er `pan:` som styrer panoreringen af en lyd i stereo. Hvis du panorerer en lyd til venstre, vil du høre den fra venstre højttaler, og hvis du panorerer en lyd til højre, vil du høre den fra højre højttaler. I Sonic Pi vil en værdi på -1 betyde "helt til venstre", 0 vil betyde "i midten", og 1 vil betyde "helt til højre". Vi kan selvfølgelig vælge enhver værdi mellem -1 og 1 for at styre den præcise placering af vores lyd.

Lad os spille et bip ud af venstre højttaler:

```
play 60, pan: -1
```

Lad os nu spille det ud af højre højttaler:

```
play 60, pan: 1
```

Lad os til sidst spille det i midten (udgangspositionen):

```
play 60, pan: 0
```

Prøv nu at more dig med at ændre amplituden og panoreringen af dine lyde!
