2.3 Synths wechseln

# Synths wechseln

Bisher hatten wir viel Spaß damit Pieptöne zu erzeugen. Aber wahrscheinlich langweilt es dich langsam, immer wieder denselben Klang zu hören. Ist das alles, was Sonic Pi zu bieten hat? Live-Coding kann doch sicher mehr als nur einen einfachen Piepton zu spielen? Aber klar doch! In diesem Abschnitt schauen wir uns die aufregende Vielfalt der Klänge, die uns Sonic Pi bietet, an.

## Synthesizer

Sonic Pi verfügt über eine ganze Palette unterschiedlicher Instrumente, die es Synths nennt (kurz für *Synthesizer - Klangerzeuger*). Wohingegen Samples bereits aufgenommene Klänge sind. Synths erzeugen neue Klänge, je nachdem, wie du sie steuerst (was wir später in diesem Tutorial untersuchen werden). Die Synths in Sonic Pi sind sehr kraftvoll und ausdrucksstark, und du wirst viel Spaß damit haben sie zu erforschen und damit zu spielen. Lass uns zuerst lernen, wie ein Synth ausgewählt wird, um ihn zu verwenden.

## Brummende Sägen und Propheten

Ein lustiger Klang ist die *Sägezahn-Welle* - probieren wir es mal aus:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Nehmen wir einen anderen Klang - den *Prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Wie wäre es beide Klänge zu verbinden? Zuerst nacheinander:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

Jetzt mehrere Töne gleichzeitig (keine Pausen mit `sleep` zwischen aufeinander folgenden Aufrufen von `play`):

```
use_synth :tb303
play 38
use_synth :dsaw
play 50
use_synth :prophet
play 57
```

Achte darauf, wie das `use_synth`-Kommando nur die nachfolgenden `play`-Kommandos beeinflusst. Stell dir das wie einen *großen Schalter* vor - neue Aufrufe von `play` werden immer den Synth benutzen, auf den der Schalter gerade zeigt. Du kannst diesen Schalter mit `use_synth` auf einen anderen Synth umschalten.


## Synths entdecken

Um zu entdecken welche Synths Sonic Pi für dich zum Spielen bereithält, schau im Synths-Option im Menü links unten im Hilfe-Fenster nach (gleich neben *FX*). Es gibt über 20 zur Auswahl. Hier sind einige meiner Favoriten:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Spiele ein bisschen herum und *wechsle die Synths, während du spielst*. Kombiniere unterschiedliche Synths, um neue Klänge zu erzeugen, oder setze sie für unterschiedliche Sektionen in deinem Stück ein.
