9.2 Live-Loops

# Live-Loops

Ok, dieser Abschnitt des Tutorials ist ein echtes Juwel. Wenn du nur einen einzigen Abschnitt lesen würdest, sollte es dieser sein. Wenn du den letzten Abschnitt über die Grundlagen von Live-Coding gelesen hast - `live_loop` ist eine einfache Art genau das gleiche zu tun, aber ohne dass du so viel schreiben musst.

Falls du den letzten Abschnitt nicht gelesen hast - `live_loop` ist der beste Weg, um mit Sonic Pi zu jammen.

Lass uns spielen. Schreibe Folgendes in einen neuen Puffer:

```
live_loop :foo do
  play 60
  sleep 1
end
```

Jetzt klicke auf `Ausführen`. Du hörst mit jedem Schlag ein einfaches Piepen. Nichts unterhaltsames daran. Klicke aber noch nicht auf `Stopp`. Ändere die `60` in `65` und klicke wieder `Ausführen`.

Wow! Es hat sich *automatisch*geändert ohne einen Schlag auszulassen. Das ist Live-Coding.

Warum es nicht ein wenig mehr nach Bass klingen lassen? Aktualisiere deinen Programm-Code, während er abläuft:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8
  sleep 8
end
```

Dann klicke auf `Ausführen`.

Lassen wir den Cut-Off sich ein wenig bewegen:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Klicke wieder auf `Ausführen`.

Füge etwas Schlagzeug hinzu:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Wechsle die Note von `e1` zu `c1`:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :c1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Nun höre nicht weiter mir zu - spiele selbst herum! Viel Spaß!
