2.3 Cambiando Sintetizadores

# Cambiando Sintetizadores

Hasta ahora nos hemos divertido mucho sólo con sonidos. Sin embargo, de seguro ya comienzas a cansarte del sonido básico de pitidos. ¿es eso todo lo que Sonic-Pi tiene para ofrecer? Tiene que haber más que tocar pitidos. Sí, hay mucho más y lo exploraremos en esta sección con el impresionante rango de sonidos que Sonic Pi tiene para ofrecer.

## Sintetizadores

Sonic Pi cuenta con varios instrumento llamados synths (una abreviación de *sintetizadores*). Mientras que los muestreos representan sonidos pre-grabados, los sintetizadores son capaces de generar nuevos sonidos dependiendo de cómo los controles (lo cual exploraremos más adelante en el tutorial). Los sintetizadores de Sonic Pi son poderosos y expresivos, y seguro que te divertirás tocando y explorándolos. Primero, aprendamos a seleccionar el synth que queremos usar.

## Sierras y Profetas

Un sonido divertido es el de la *onda sierra* - probémoslo:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Probemos otro sonido - *prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

¿Qué tal si combinamos ambos sonidos? Pongamos uno después del otro:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

Ahora múltiples sonidos al mismo tiempo (al no dormir entre llamados sucesivos a `play`):

```
use_synth :tb303
play 38
use_synth :dsaw
play 50
use_synth :prophet
play 57
```

Debes notar que el comando `use_synth` sólo afecta a las siguientes llamadas a `play`. Piensa en él como un *gran conmutador* - nuevas llamadas a `play` tocarán el sintetizador que esté en uso. Puedes cambiar el conmutador a un nuevo sintetizador con `use_synth`.


## Descubriendo Sintetizadores

Para saber qué sintetizadores tiene Sonic Pi, échale un vistazo a la opción Sintetizadores en el menú al final de esta pantalla de ayuda (entre Ejemplos y Efectos). Hay más de 20 entre los que elegir. Aquí están algunos de mis favoritos:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Ahora prueba a *cambiar los sintetizadores durante la ejecución de tu música*. Diviértete combinando sintetizadores para hacer nuevos sonidos así como utilizando diferentes sintetizadores para diferentes secciones de tu música.
