Programación en directo (Live Coding)

# Programación en directo (Live Coding)

El último mes le echamos un vistazo a cinco técnicas importantes para manejar bien el live coding; en otras palabras, exploramos cómo podemos usar Sonic Pi para hacer código, igual que usaríamos un instrumento musical. Uno de los conceptos que mencionamos es el de la práctica. Este mes vamos a sumergirnos en más código, y vamos a entender por qué practicar live coding es importante, y cómo podrías empezar.


## Practica regularmente

El mejor consejo que te puedo dar es que te asegures de practicar de forma regular. Por norma, suelo practicar 1 o 2 horas cada día, pero con 20 minutos es suficiente para empezar. Estamos buscando practicar poquito pero cada día; así que si sólo puedes dedicarle 10 minutos, sigue siendo un buen comienzo.

Consejo de práctica nº 1 - empieza a desarrollar una rutina de práctica. Encuentra un buen momento del día que funcione bien para ti, y practica en ese tiempo tantos días de la semana como puedas. Pronto estarás contando las horas para tu sesión de práctica diaria.


## Aprende Mecanografía Táctil

Si ves tocar a un/a músic@ profesional tocando en directo, probablemente te darás cuenta de varias cosas. En primer lugar, cuando tocan no miran su instrumento. Sus dedos, brazos y su cuerpo entero saben qué teclas pulsar, qué cuerdas rasguear o qué tambores percutir, sin tener que pensarlo mucho. Esto se conoce como "memoria muscular" y, aunque suene como algo que sólo hacen l@s profesionales, es igual que cuando aprendiste a andar o a montar en bicicleta; práctica a través de la repetición. L@s live coders usan su memoria muscular para liberar sus mentes; no tienen que pensar dónde mover sus dedos, así que pueden centrarse en la música. Esto se conoce como touch typing o mecanografía táctil - escribir sin mirar al teclado.

Consejo de práctica nº 2 - aprende mecanografía táctil. Hay muchas apps, páginas web e incluso juegos que te pueden ayudar a conseguirlo. Encuentra uno que te guste, y úsalo de forma regular hasta que puedas programar sin mirar al teclado.


## Programa de pie

El cuerpo de un/a músic@ está acondicionado para tocar su instrumento. Por ejemplo, un/a trompetista necesita soplar fuerte, un/a guitarrista necesita agarrar el mástil con fuerza, y un/a baterista necesita golpear la batería durante largos periodos de tiempo. ¿Y qué hay de corporal en el live coding? Como l@s DJs, l@s live coders suelen tocar de pie; ¡algun@s incluso bailan mientras programan! Si practicas live coding sentad@ en tu mesa y luego tienes que estar de pie cuando llegues al concierto, vas a notar la diferencia, y se te va a hacer difícil y frustrante.

Consejo de práctica nº 3 - ponte de pie mientras practicas. La forma más fácil de hacerlo es usar un escritorio de altura regulable. No obstante, si eres como yo y no tienes uno en casa, hay varios apaños que puedes hacer. Lo que suelo hacer yo es usar una tabla de planchar, que funciona bastante bien. También puedes apilar varias cajas o libros grandes en un escritorio normal, y poner tu teclado encima. Asegúrate también de estirarte cuando antes de empezar a practicar, e intenta moverte (o bailar) un poco durante la sesión. Recuerda, nadie te está mirando, así que diviértete, y te sentirás mucho más natural en el escenario.


## Montando tu práctica

La mayoría de los instrumentos necesitan ser montados y afinados antes de tocar. A no ser que seas una estrella del rock con un autobús lleno de encargad@s de equipo, serás tú quien monte su instrumento antes de cada concierto. El momento de montar el instrumento suele ser estresante, y es fácil que ocurra algún problema. Una forma de suavizar esta situación en los conciertos es que incluyas el proceso de puesta a punto en tus sesiones de práctica.

Consejo de práctica nº 4 - montar tu equipo también forma parte de tu práctica. Por ejemplo, encuentra una caja o una bolsa donde puedas dejar tu Raspberry Pi, tu teclado, etc. Antes de cada sesión de práctica, saca todas las partes, conecta todo, enciende tu Raspberry Pi... así hasta que tengas Sonic Pi encendido y puedas hacer música. Cuando hayas acabado de tocar, tómate tu tiempo para guardar todo en su sitio. Esto te puede llevar algo de tiempo al principio, pero antes de que te des cuenta, serás capaz de montar y desmontar tu equipo muy rápido, sin pensar.


## Experimenta Musicalmente

Una vez hayas montado todo y estés list@ para empezar a tocar, puede que te cueste ver por dónde empezar. Un problema que suele tener la gente es que imaginan qué música quieren hacer pero no saben cómo tocarla, lo que les frustra. ¡Hay gente que no sabe qué música quiere hacer! En primer lugar, no te preocupes; es muy normal y le pasa a cualquier músic@ (incluso si llevan practicando mucho tiempo). Es mucho mejor hacer música que no te gusta exactamente, que no hacer música.

Consejo de práctica nº 5 - dedica parte de tu tiempo a hacer música que no te guste. Tómate tu tiempo para explorar nuevos sonidos e ideas. No te preocupes porque pueda sonar mal si no es el estilo que te gusta. Cuando experimentas de esta forma, ¡aumentas la probabilidad de encontrarte con música que te encante! Aunque el 99% de la música que hagas suene mal, ese 1% restante puede ser el riff o la introducción de tu nueva canción. Olvídate de las partes que no te gusten, y recuerda las que sí te hayan gustado. Cuando haces música con código es todavía más fácil: ¡sólo tienes que darle a Guardar!


## Escucha el Código

Muchos músicos pueden mirar una partitura y escuchar la música en su cabeza sin tener que tocarla. Es una habilidad muy útil y merece la pena incorporarla a tus sesiones de práctica de codificación en directo. Lo importante es ser capaz de entender cómo va a sonar el código. No es necesario que puedas oírlo exactamente en tu cabeza, pero sí es útil saber si el código va a ser rápido, lento, fuerte, rítmico, melódico, aleatorio, etc. El objetivo final es ser capaz de invertir este proceso: ser capaz de escuchar música en tu cabeza y saber qué código escribir para hacerla. Puede que te lleve mucho tiempo dominar esto, pero una vez que lo hagas, serás capaz de improvisar en el escenario y expresar tus ideas con fluidez.

Consejo de práctica nº 5 - escribe código en Sonic Pi, pero no le des todavía a Ejecutar. Intenta imaginarte qué va a sonar con ese código. Cuando lo tengas, dale a Ejecutar, escucha, y piensa en qué acertaste y en qué te equivocaste. Repite este proceso hasta que se convierta en una parte natural de tu proceso creativo. Yo cuando practico suelo tener una idea bastante clara de cómo va a sonar mi código. Sin embargo, hay veces en las que me sorprendo con lo que suena; en ese momento paro y pienso en dónde me he equivocado. Cada vez que pasa esto, aprendo nuevos trucos que me permiten expresarme de nuevas formas.

## Elimina todas las distracciones

Un problema muy común al practicar es distraerte con otras cosas. Practicar es duro y requiere disciplina, da igual el estilo que toques - desde jazz hasta clásica o electrónica. Si te cuesta empezar a tocar o progresar con lo que tienes, es fácil que te pongas a ver las redes sociales, que mires cosas en Internet, etc. Si te has planificado para practicar 20 minutos, es importante que intentes dedicar ese tiempo de forma productiva.

Consejo de práctica nº 7 - antes de empezar a practicar, intenta deshacerte de todas las distracciones que puedas. Por ejemplo, desconéctate de Internet, deja tu móvil en otro cuarto, e intenta practicar en un sitio en silencio, donde no te vayan a molestar. Intenta concentrarte en escribir tu música; siempre puedes a tus distracciones cuando acabes.


## Escribe un diario de práctica

Cuando practiques, tu mente estará llena de ideas nuevas: nuevas direcciones en tu estilo musical, nuevos sonidos que quieres probar, nuevas funciones para escribir, etc. Estas ideas suelen ser tan interesantes que puede que dejes de hacer lo que estés haciendo, para ponerte a trabajar en esas ideas. ¡Esta es otra forma de distracción!

Consejo de práctica nº 8 - escribe un diario de práctica con tu teclado. Cuando tengas una nueva idea, para tu sesión de práctica unos segundos, escribe la idea rápidamente, y olvídate de ella y sigue practicando. Así puedes dedicar tiempo más tarde para pensar en tus ideas, cuando hayas acabado de practicar.


## Juntándolo todo

Intenta establecer una rutina de práctica que incorpore todas las ideas nuevas que puedas. Intenta que las sesiones sean divertidas, pero ten en cuenta que la práctica puede ser dura y requerir bastante trabajo en ocasiones. Sin embargo, todo esto merecerá la pena cuando hayas creado tu primera pieza, o cuando hayas tocado tu primer concierto. Recuerda, ¡la práctica es la clave del éxito!
