A.16 Comment pratiquer le codage en direct

# 8 astuces pour la pratique du codage en direct

Le mois dernier, nous avons étudié cinq techniques importantes pour maitriser le codage en direct - en d'autres mots, nous avons exploré comment nous pouvions utiliser Sonic Pi pour approcher le code de la même façon que nous le ferions avec un instrument de musique. L'un des concepts importants dont nous avons discuté est la pratique. Ce mois-ci, nous allons approfondir notre compréhension de pourquoi la pratique du codage en direct est importante et comment vous pouvez commencer à le faire.


## Pratiquer régulièrement

Le conseil le plus important est de vous assurer de pratiquer régulièrement. Par discipline, je pratique normalement 1-2 heures par jour, mais 20 minutes est correct quand vous débutez. Un petit peu mais souvent est ce que vous visez - donc si vous ne pouvez effectuer que 10 minutes, c'est un bon début.

Astuce de pratique #1 - commencer à développer une routine de pratique. Trouvez un bon moment dans la journée qui vous convient et essayer de pratiquer à ce moment le plus grand nombre de jours dans une semaine que vous pouvez. Vous allez rapidement avoir hâte de faire votre session quotidienne.


## Apprenez à taper sans regarder le clavier

Si vous observez un musicien professionnel qui performe sur scène, vous remarquez certainement quelques éléments. Premièrement, ils ne fixent pas leur instrument lorsqu'ils jouent. Leurs doigts, bras et corps savent quelles sont les touches à appuyer, cordes à gratter ou les tambours à frapper sans avoir trop à y penser. Ceci est connu comme la "mémoire musculaire" et même si cela peut ressembler à quelque chose qu'uniquement les professionnels peuvent faire, c'est la même chose que lorsque vous avez appris à marcher ou à faire de la bicyclette, la pratique par répétition. Les codeurs en direct utilisent leur mémoire musculaire pour libérer leur esprit d'avoir à penser à quel endroit placer leurs doigts afin qu'ils puissent se concentrer sur la musique. Cela s'appelle du tape-touche - taper sans avoir besoin de regarder le clavier.

Astuce de pratique #2 - apprenez comment taper sans regarder le clavier. Il y a plusieurs applications, sites web et même des jeux qui peuvent vous aider à réussir. Trouvez-en un dont vous aimez l'allure et tenez vous en à lui jusqu'à ce que vous soyez capable de programmer sans regarder le clavier.


## Coder en position debout

Le corps d'un musicien est conditionné pour jouer son instrument. Par exemple, un trompettiste doit être capable de souffler fort, un guitariste doit être capable de tenir le manche avec force et un batteur doit être capable de frapper continuellement les tambours pour de longues périodes de temps. Alors, qu'est-ce qui est physique à propos du codage en direct ? Tout comme les DJs, les codeurs en direct performent habituellement debout et certains dansent même en codant ! Si vous pratiquez votre codage en direct assis à un bureau et que vous avez à vous levez pour jouer pour un concert, vous trouverez probablement cette différence difficile et frustrante.

Astuce de pratique #3 - tenez vous debout en pratiquant. La façon la plus facile de faire cela est en utilisant un bureau à usage debout. Par contre, si comme moi vous n'en n'avez pas à la maison, il existe quelques options à faible coût. L'approche que je prends est d'utiliser une table à repasser, ce qui fonctionne assez bien. Une autre façon est d'empiler quelques boites ou de gros livres sur un bureau normal et placer votre clavier sur le dessus. De plus, n'oubliez pas de vous étirez avant de commencer votre pratique et essayez de danser un peu durant votre session. Rappelez-vous, personne ne vous regarde, donc ayez du plaisir et vous vous sentirez beaucoup plus naturel sur scène.


## Mise en place de la pratique

La majorité des instruments nécessitent de l'assemblage et des ajustements avant que vous puissiez en jouer. À moins que vous soyez une étoile du rock avec un autobus rempli de techniciens, vous aurez à mettre en place votre propre instrument avant votre concert. C'est souvent un moment stressant et des problèmes peuvent arriver facilement. Une façon de vous aider avec cela est d'incorporer le processus de mise en place dans vos sessions d'entraînement.

Astuce de pratique #4 - traiter la mise en place comme une partie importante de votre pratique. Par exemple, ayez une boite ou un sac dans lequel vous pouvez conserver votre Raspberry Pi et votre clavier etc. Avant chaque session de pratique, sortez toutes les pièces, connectez tout et aller dans le processus de démarrage jusqu'à ce que vous ayez Sonic Pi qui s'exécute et que vous puissiez faire des sons. A la fin de votre entraînement, prenez le temps de tout remballer minutieusement. Cela peut prendre du temps au départ, mais en peu de temps vous serez capable de mettre en place et emballer tout incroyablement rapidement sans que vous ayez besoin d'y penser.


## Expérimenter musicalement

Une fois que tout est mis en place et que vous êtes prêt à faire de la musique, il se peut que vous ayez de la difficulté à savoir par où commencer. Un problème que plusieurs personnes rencontrent est qu'elles ont une bonne idée du type de sons qu'elles veulent produire, mais elles sont frustrées de ne pas être capable de les produire. Certaines personnes ne savent même pas quel type de sons elles veulent produire ! La première chose à faire est de ne pas s'inquiéter - c'est très commun et ça arrive à tous les musiciens - même s'ils pratiquent depuis longtemps. C'est beaucoup plus important de faire des sons que vous n'aimez pas que de ne pas faire de sons du tout.

Astuce de pratique #5 - passez du temps à faire des sons et de la musique que vous n'aimez pas. Essayez de conserver du temps pour explorer des nouveaux sons et des idées. Ne vous inquiétez pas que cela puisse sonner terrible si ce n'est pas le style que vous recherchez. Quand vous expérimentez de cette manière, vous augmentez les chances de tomber sur un son ou une combinaison de sons que vous aimez ! Même si 99% des sons que vous faites sont mauvais, ce 1% peut être le riff ou l'intro de votre nouvelle piste. Oubliez les choses que vous n'aimez pas et rappelez-vous de celles que vous aimez. C'est encore plus facile quand vous faites de la musique avec du code - vous n'avez qu'à presser sauvegarder !


## Entendre le code

Plusieurs musiciens peuvent regarder une partition de musique et entendre la musique dans leur tête sans avoir à la jouer. C'est une compétence très utile et ça vaut la peine de l'incorporer dans vos sessions de pratique de codage en direct. L'important est d'être capable d'avoir une certaine compréhension de comment va sonner le code. Vous n'avez pas besoin d'être capable de l'entendre exactement dans votre tête, mais il est utile de savoir si le code sera rapide, lent, fort, rythmé, mélodieux, aléatoire, etc. Le but final est d'être capable d'inverser le processus par la suite - être capable d'entendre de la musique dans votre tête et savoir comment la coder. Cela peut vous prendre beaucoup de temps à maîtriser, mais quand c'est le cas, vous serez capable d'improviser sur scène et exprimer vos idées de manière fluide.

Astuce de pratique #6 - écrivez un peu de code dans Sonic Pi, mais ne pressez pas sur le bouton Exécuter. Au lieu de cela, essayez d'imaginer quel son ça va produire. Puis, pressez Exécuter, écoutez, et pensez sur quoi vous aviez raison et sur quoi vous aviez tort. Continuez de répéter cela jusqu'à ce que ça devienne une partie naturelle de votre processus de codage. Quand je pratique, j'ai normalement une bonne idée de comment va sonner le code. Cependant, je suis encore parfois surpris, et alors j'arrête et prends du temps pour penser à propos de quoi j'avais tort. À chaque fois que cela se produit, j'apprends de nouveaux trucs qui me permettent de m'exprimer de nouvelles façons.

## Enlevez toutes les distractions

Un problème courant en pratiquant est de devenir distrait par d'autres choses. La pratique est difficile et demande une réelle discipline peu importe le type de musique que vous jouez - du jazz au EDM en passant par le classique. Si vous avez de la difficulté à commencer ou faire des progrès, c'est souvent trop facile d'aller sur un réseau social, ou de regarder quelque chose sur internet etc. Si vous vous êtes fixé un objectif d'une pratique d'une durée de 20 minutes, c'est important d'essayer de prendre tout ce temps en étant le plus productif possible.

Astuce de pratique #7 - avant de commencer votre pratique, enlevez le plus de distractions possible. Par exemple, déconnectez-vous d'internet, laissez votre téléphone dans une autre pièce et essayez de pratiquer dans un endroit tranquille où il est peu probable que vous soyez dérangé. Essayez de vous concentrer sur le codage de la musique et vous pourrez retourner à vos distractions quand vous aurez terminé.


## Tenir un journal d'entraînement

Quand vous pratiquez, vous ressentirez souvent que votre esprit est plein de nouvelles idées enthousiasmantes - nouvelles directions musicales, nouveaux sons à essayer, nouvelles fonctions à écrire, etc. Ces idées sont souvent tellement intéressantes que vous allez peut-être interrompre ce que vous faisiez pour commencer à travailler sur l'idée. Il s'agit d'une autre forme de distraction !

Astuce de pratique #8 - conservez un journal de pratique près de votre clavier. Quand vous avez une nouvelle idée excitante, arrêtez temporairement votre session, notez rapidement l'idée, et puis oubliez la pour continuer à pratiquer. Vous pouvez par la suite passer du temps de qualité à penser et à travailler vos idées une fois que vous avez terminé de pratiquer.


## Rassemblons tout

Essayez d'établir une routine de pratique qui inclut autant de ces idées que possible. Essayez de rendre les sessions aussi plaisantes que possible, mais soyez prévenus que certaines sessions de pratiques seront difficiles et auront l'apparence d'un travail. Toutefois, tout cela aura valu la peine lorsque vous aurez créé votre première pièce ou que vous aurez donné votre première performance. Rappelez-vous, la pratique est la clé du succès !
