10.2 Sync

# Sync

La sezione 5.7 ha introdotto le funzioni `cue` e `sync`, questo quando c'è da risolvere la questione della sincronizzazione dei thread. Quello che non ha chiarito però è che si tratta proprio del sistema Time State che fornisce questa funzionalità. Si dà il caso che `set` è in realtà una variazione di `cue`: esso è costruito sopra la stessa funzionalità di base, cioè quella di inserire informazioni nel sistema Time State. Inoltre, `sync` è anche progettato in modo tale che funzioni perfettamente con Time State - qualsiasi informazione abbiamo intenzione di memorizzare in Time State, con cui possiamo sincronizzarci. In altre parole - *ci "sincronizziamo" sugli eventi ancora da inserire in Time State*.

## Aspettando gli Eventi

Diamo un rapido sguardo a come usare `sync` per attendere che nuovi eventi siano aggiunti al Time State:

```
in_thread do
  sync :foo
  sample :ambi_lunar_land
end
sleep 2
set :foo, 1
```

foo

Nota che `sync` attende sempre gli *eventi futuri* e che bloccherà il thread attuale in attesa di un nuovo evento. Inoltre, erediterà il tempo logico del thread che lo ha innescato tramite `set` o `cue`, così che può anche essere usato per la sincronizzazione del tempo.

## Passare valori nel Future

foo

```
in_thread do
  amp = sync :foo
  sample :ambi_lunar_land, amp: amp
end
sleep 2
set :foo, 0.5
```

Nota che i valori che vengono passati attraverso `set` e `cue` devono essere "thread safe" - ad esempio: anelli immutabili, numeri, simboli o stringhe fissate. Sonic Pi lancia un errore se il valore che stai tentando di memorizzare nel Time State è non valido.
