10.2 ショートカット一覧表

# ショートカット一覧表

以下は、Sonic Piで利用可能な主なショートカットをまとめたものです。動機と背景については、セクション10.1を参照してください。

## 規定

このリストでは下記の規定に準拠します（WindowsとLinuxの*Meta*キーは*Alt*キー、そしてMacは*Cmd*キー）:

* `C-a` は*Control*キーを押さえながら*a*キー、両方を同時にを押した後に離す事を意味しています。
* `M-r` は*Meta*キーを押さえながら*r*キー、両方を同時にした後に離す事を意味しています。
* `S-M-z` は*Shift*キーを押さえながら*Meta*キー、そして最後に*z*キー全てを同時に押した後に離す事を意味しています。
* `C-M-f`は*Control* キーを押さえながら*Meta*キー、そして最後に*f*キー全てを同時に押した後に離す事を意味しています。

## 主なアプリケーションの操作

* `M-r` - コードを実行
* `M-s` - コードを停止
* `M-i` - ヘルプシステムを表示
* `M-p` - 設定を表示
* `M-{` - 左のBufferに切り替え
* `M-}` - 右のBufferに切り替え
* `S-M-0` - Switch to buffer 0
* `S-M-1` - Switch to buffer 1
* ...
* `S-M-9` - Switch to buffer 9
* `M-+` - 文字サイズを大きく
* `M--` - 文字サイズを小さく


## 選択/コピー/張り付け

* `M-a` - 全てを選択
* `M-c` - 選択箇所をコピー
* `M-]` - 選択箇所をコピー
* `M-x` - 選択箇所をカット
* `C-]` - 選択箇所をカット
* `C-k` - カーソルから行の末尾まで全ての文字を消去する
* `M-v` - エディタへ張り付け
* `C-y` - エディタへ張り付け
* `C-SPACE` - マークを設定します。以降のナビゲーション操作で選択箇所を変更できます。`C-g`でマークを解除します。

## 文字の操作

* `M-m` - テキストを整形
* `Tab` - 現在の行または選択箇所のテキストを整形（または、自動補完を選択）
* `C-l` - 真ん中へ移動
* `M-/` - 現在の行または選択箇所をコメント／コメント解除
* `C-t` - カーソルの前後の文字を入れ替え
* `M-u` - カーソルの後ろの単語（または選択箇所）を大文字に変換
* `M-l` - カーソルの後ろの単語（または選択箇所）を小文字に変換

## ナビゲーション

* `C-a` - 行の先頭に移動
* `C-e` - 行の末尾に移動
* `C-p` - ひとつ前の行に移動
* `C-n` - 次の行に移動
* `C-f` - 一文字進む
* `C-b` - 一文字戻る
* `M-f` - 一単語進む
* `M-b` - 一単語戻る
* `C-M-n` - 現在の行または選択箇所を下に移動
* `C-M-p` - 現在の行または選択箇所を上に移動
* `S-M-u` - 10行上に移動
* `S-M-d` - 10行下に移動
* `M-<` - Bufferの先頭に移動
* `M->` - Bufferの末尾に移動

## 削除

* `C-h` - 前の文字を削除
* `C-d` - 次の文字を削除

## 高度なエディタの機能

* `C-i` - カーソルの下の単語のドキュメントを表示
* `M-z` - アンドゥ（行った操作を取り消し、元の状態に戻る）
* `S-M-z` - リドゥ（一旦取り消した操作をやり直す）
* `C-g` - エスケープ
* `S-M-f` - フルスクリーンモードを切り替え
* `S-M-b` - ボタンの表示を切り替え
* `S-M-l` - ログの表示を切り替え
* `S-M-m` - ライト／ダークモードを切り替え
* `S-M-s` - Bufferの内容をファイルに保存
* `S-M-o` - Bufferの内容をファイルから読み込む
