1.2 인터페이스 둘러보기

# 소닉 파이(Sonic Pi) 인터페이스

소닉 파이는 음악을 코딩하기 위한 매우 간단한 인터페이스를 가지고 있습니다. 잠시 시간을 내어서 살펴보죠.

![Sonic Pi Interface](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Play Controls
* *B* - 에디터 컨트롤들
* *C* - 프로그램 정보와 도움말
* *D* - 코드 에디터
* *E* - 환경설정 패널
* *F* - 로그 뷰어
* *G* - 도움말 시스템
* *H* - 스코프 뷰어
* *F* - 로그 뷰어

## A. Play Controls

이 핑크색 버튼들은 사운드를 시작하고 중지하는데 쓰는 주요한 제어장치입니다. 에디터에서 코드를 실행할 때 사용하는 *Run* 버튼, 실행 중인 코드를 중지시킬 때 쓰는 *Stop* 버튼, 코드를 파일로 저장할 때 쓰는 *Save* 버튼, 연주되는 사운드를 녹음할 때(WAV 파일로) 사용하는 *Record* 버튼이 있습니다.

## B. Editor Controls

These orange buttons allow you to manipulate the code editor. The *Size +* and *Size -* buttons allow you to make the text bigger and smaller.

## C. 프로그램 정보와 도움말

이곳의 파랑색 버튼들은 정보, 도움말, 환경설정에 접근할 때 사용합니다. *Info* 버튼은 핵심 개발진,역사,기여자,커뮤니티 같은 소닉 파이 자체에 관한 정보를 담고 있는 윈도우를 열어줍니다. *Help* 버튼은 도움말 시스템(*G*)을 열거나 끄고, *Prefs* 버튼은 기본적인 시스템 변수을 조정할 수 있는 환경설정 윈도우를 열거나 끕니다.

## D. 코드 에디터

이 영역은 여러분이 코드를 쓰거나 음악을 작곡/연주하는 곳입니다. 여러분이 코드를 쓰거나, 삭제하거나, 자르거나, 붙이는 작업을 할 수 있는 심플한 텍스트 에디터 입니다. 아주 간단한 워드(Word) 프로그램이나 구글 독스(Google Docs) 같다고 생각하면 됩니다. 이 에디터는 코드 내에서 갖는 의미에 따라 자동적으로 단어에 색을 입힙니다. 처음에는 이상하게 보일 수도 있게지만, 곧 매우 유용하다는 것을 알게 될 것입니다. 예를 들면, 어떤 단어가 파랑색이라면 그것이 숫자라는 것을 알게 될 것입니다.

## E. 환경설정 패널

Sonic Pi supports a number of tweakable preferences which can be accessed by toggling the *prefs* button in the Info and Help button set. This will toggle the visibility of the Prefs Panel which includes a number of options to be changed. Examples are forcing mono mode, inverting stereo, toggling log output verbosity and also a volume slider and audio selector on the Raspberry Pi.

## F. Log Viewer

코드를 실행하면, 프로그램이 수행하는 작업에 대한 정보가 로그 뷰어에 표시됩니다. 기본적으로 여러분이 생성한 모든 사운드에 대한 메시지를 사운드가 실행된 정확한 시간과 함께 볼 수 있습니다. 이 기능은 코드를 디버깅하고 코드가 하는 일을 이해하는데 매우 유용합니다.

## G. Help System

소닉 파이 인터페이스의 가장 중요한 부분 중의 하나는 화면 하단부에 보이는 도움말 시스템입니다. 이 기능은 파랑색 *Help* 버튼을 눌러서 켜거나 끌 수 있습니다. 도움말 시스템은 이 튜토리얼, 사용가능한 신스, 샘플, 예제, FX 및 소닉 파이가 음악 코딩을 위해 제공하는 전체 함수목록을 포함하여 소닉 파이의 모든 측면에 대한 도움말과 정보를 포함하고 있습니다.

## H. Scope Viewer

스코프 창은 들리는 소리를 볼 수 있도록 만들어 줍니다. 톱니파가 톱니처럼 보이고, 기본 삐소리가 곡선 사인파인 것을 쉽게 알 수 있습니다. 선의 크기로 큰 소리와 작은 소리의 차이를 확인할 수도 있습니다. 3가지 종류의 스코프가 있습니다 - 기본값은 왼쪽 채널과 오른쪽 채널이 조합된 스코프이며, 각 채널에 대해 각각 별도의 스코프를 표시하는 스테레오 스코프도 있습니다. 마지막으로 왼쪽 채널과 오른쪽 채널사이의 위상 관계를 보여주는 리사주 곡선 스코프가 있으며, 이것은 소리로 예쁜 그림을 그릴 수 있습니다 (https://en.wikipedia.org/wiki/Lissajous_curve).

## I. Cue Viewer

All internal and external events (called cues in Sonic Pi) are automatically logged in the Cue Viewer. For example, if you have a MIDI controller connected and press one of its buttons, you'll see a new cue event in the Cue Viewer telling you the name of the controller and which button you pressed. Once you've mastered the basics of making and producing sounds, you'll start to want to cue sounds or whole sections of sounds based on events such as these. A cue event is just an indication that something happened. For example, every time a live loop spins round, it sends a cue event out which is logged in the Cue Viewer. Also, external events such as MIDI messages from connected MIDI equipment and OSC messages from other programs or computers are also displayed in the Cue Viewer. It is also possible to directly generate cue events using the `cue` function. Anything that appears in the Cue Viewer can be used to trigger something happening. This is covered in more detail in Sections 10 to 12 of this tutorial.
