2.2 Synthesizer Opties

# Synthesizer Opties: Amp en Pan

Naast dat je kan bepalen welke noot er gespeeld wordt of welke sample er wordt getriggert, biedt Sonic Pi een heel scala aan mogelijkheden om geluiden te bewerken en manipuleren. We gaan vele daarvan in deze handleiding bekijken en in het hulp systeem zijn deze "opties" voorzien van uitgebreide documentatie. De belangrijkste op dit moment zijn: *amplitude* (sterkte) en *pan* (balans). Laten we eerst even bekijken wat opties nu eigenlijk zijn.


## Opties

Sonic Pi ondersteunt het concept van opties (afgekort: opts) voor haar synths. Opts zijn controle-elementen die je samen met het commando `play` doorgeeft. Ze wijzigingen en manipuleren het afgespeelde geluid. Elke synth heeft zijn eigen unieke set opts om haar geluid haarfijn af te kunnen stemmen. Er zijn ook opts die bij elke synth, of bij elk geluid gebruikt kunnen worden. Zoals `amp:` en "envelope" (geluidsverloop) opties (Waar we in een andere sectie dieper op ingaan).

Opts bestaan uit twee belangrijke delen, een naam (de naam van het element waar je controle over wil hebben) en de waarde hiervan (de mate van controle over dit element). Een voorbeeld, je hebt een opt genaamd `kaas:` en je wilt deze instellen op een waarde van `1`.

Opts worden samen met het `play` commando's doorgegeven, gescheiden door een komma `,` gevolgd door de naam van de optie, we kiezen hier `amp:` (vergeet de dubbele punt niet `:`) gevolgd door een spatie en de waarde van de optie. Bijvoorbeeld:

```
play 50, kaas: 1
```

(Let op dat `kaas:` geen geldige opt is, we gebruiken deze alleen als voorbeeld).

Je kunt meerdere opts tegelijk doorgeven door deze te scheiden door een komma:

```
play 50, kaas: 1, eieren: 0.5
```

De volgorde van de opts maakt niet uit, dus het volgende is identiek:

```
play 50, eieren: 0.5, kaas: 1
```

Opts die door de synth niet worden herkent zullen gewoon genegeerd worden (zoals `kaas` en `eieren` duidelijk nergens op slaan qua opt namen!)

Mocht je per ongeluk twee keer dezelfde opt hebben ingevoerd maar met verschillende waarden, dan zal de laatste waarde winnen. Bijvoorbeeld, `eieren:` zal de waarde `2` hebben in plaats van `0.5`:

```
play 50, eieren: 0.5, kaas: 3, tomaat: 0.1, eieren: 2
```

Opts worden door veel items in Sonic Pi geaccepteerd, dus probeer deze onder de knie te krijgen, het loont echt! Laten we wat spelen met onze eerste opt: `amp:`.

## Amplitude

Amplitude is de representatie van het geluidsvolume door een computer. Een hoge amplitude produceert het geluid met een luid volume en een lage amplitude met een zacht volume. Net zoals Sonic Pi getallen gebruikt om noten en tijden aan te geven, gebruikt het getallen om de amplitude te bepalen. Een amplitude van `0` is stil (je zult niets horen) en een amplitude van `1` is een normaal volume. Je kan het volume zelfs nog opdrijven en verhogen tot 2, 10, 100. Maar je moet er dan wel rekening mee houden dat, wanneer het globale volume te hoog wordt, Sonic Pi een zogenaamde compressor inschakelt die het geluid zal onderdrukken om ervoor te zorgen dat je oren gespaard blijven. Dit kan het geluid dan weer dof en vreemd doen laten klinken. Dus is het beter om lage amplitudes te gebruiken, dwz. tussen 0 en 0.5 om compressie te vermijden.


## Amp 't op

Om de amplitude van een geluid te veranderen, kan je de `amp:` optie gebruiken. Bijvoorbeeld, om op een gemiddelde amplitude af te spelen, gebruik je 0.5:

```
play 60, amp: 0.5
```

Afspelen op een dubbel zo hoge amplitude gebruik dan 2:

```
play 60, amp: 2
```

De `amp:` opt verandert enkel de `play` oproep waarmee deze wordt geassocieerd. In dit voorbeeld zal de eerste oproep dus op de helft van het volume spelen en de tweede op de standaard-instelling (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Natuurlijk kun je verschillende `amp:` waarden per `play` oproep gebruiken:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Pannen

Een ander leuke opt om te gebruiken is `pan:` die bepaalt de panning van een geluid in stereo. Naar links pannen betekent dat je het geluid door de linker-luidspreker hoort, naar rechts pannen betekent dat je het geluid door de rechter-luidspreker hoort. Een waarde van -1 betekend helemaal links, 0 betekend in het midden en 1 betekend weer helemaal rechts van ons stereobeeld. Natuurlijk zijn we vrij om elke waarde tussen -1 en 1 te gebruiken om de exacte positie van ons geluid te bepalen.

Laten we eens een bliepje uit de linker-luidspreker laten horen:

```
play 60, pan: -1
```

En nu uit de rechter-luidspreker:

```
play 60, pan: 1
```

En nu terug vanuit het midden (standaard positie):

```
play 60, pan: 0
```

Doe nu maar, en veel plezier met het veranderen van de amplitude en het pannen van je geluiden!
