9.2 Live Loops

# Live Loops

OK, dus dit gedeelte van de handleiding is de echte parel. Als je maar één gedeelte zou kunnen lezen, zou het deze moeten zijn. Als je de vorige sectie van Live codering grondbeginselen leest, is 'live_loop' een eenvoudige manier om precies dat te bereiken, maar zonder zo veel code te hoeven schrijven.

Als je de vorige sectie niet gelezen hebt,  `live_loop` is de beste manier om  met Sonic Pi te jammen.

Laten we hiermee even spelen. Schrijf het volgende in een nieuwe buffer:

```
live_loop :foo do
  play 60
  sleep 1
end
```

Druk op de afspeel knop. Je hoort elke tel een zelfde basis bliep. Niks opwindend aan. Maar druk nog niet op Stop. Verander de `60` naar `65` en druk terug op Afspelen.

Woeha! Het veranderde *automatisch* zonder een tel te missen. Dit is Live Coding.

Waarom deze niet veranderen aar iets meer Bass-achtig? Gewoon je code updaten terwijl het speelt:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8
  sleep 8
end
```

Sla Afspelen aan.

Laten we de cutoff wat rond-bewegen:

```
live_loop :foo do
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Sla Afspelen opnieuw aan.

Voeg wat drums toe:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :e1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Verander de noot van `e1` naar `c1`:

```
live_loop :foo do
  sample :loop_garzul
  use_synth :prophet
  play :c1, release: 8, cutoff: rrand(70, 130)
  sleep 8
end
```

Stop nu met naar mij te luisteren en ga zelf aan de slag! Veel plezier!
