2.3 Zmienianie Syntezatorów

# Zmienianie Syntezatorów

Do tej pory bawiliśmy się całkiem nieźle, tworząc wiele fajnych dźwięków. Jest jednak bardzo prawdopodobne, że ten podstawowy dźwięk zaczyna Cię już powoli nudzić. Czy to jest wszystko, na co stać Sonic Pi? Przecież kodowanie na żywo na pewno daje dużo więcej możliwości, niż tylko granie jednego prostego dźwięku bip? Owszem, są inne możliwości. W tym rozdziale poznasz fascynującą paletę dźwięków, jaką oferuje Ci Sonic Pi.

## Syntezatory

Sonic Pi posiada szeroki wachlarz instrumentów, będących *syntezatorami*. Zważywszy na to, że sample (próbki) reprezentują nagrane dźwięki, syntezatory mają możliwość generowania nowych dźwięków zależnych od tego, jak je kontrolujesz (w tym samouczku dowiesz się o tym później). Syntezatory Sonic Pi są bardzo potężne i ekspresyjne. Będziesz miał wiele radości podczas poznawania i zabawy nimi. Na początku jednak nauczmy się, jak wybierać aktualnie grający syntezator.

## Brzęczące syntezatory saw i prophet

Fajnym dźwiękiem jest *saw wave* - spróbujmy:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

A teraz spróbujmy innego dźwięku - syntezatora *prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Co powiesz na połączenie dwóch dźwięków? Jeden po drugim:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
```

A teraz kilka dźwięków równocześnie (nie ma `sleep` między kolejnymi wywołaniami `play`):

```
use_synth :tb303
play 38
use_synth :dsaw
play 50
use_synth :prophet
play 57
```

Zauważ, że polecenie `use_synth` wywiera wpływ tylko kolejne polecenia `play`. Pomyśl o nim jako o *dużym przełączniku* - kolejne wywołania polecenia `play` będą używać syntezatora, który jest w danym momencie wskazany. Możesz zmienić aktualny syntezator na inny, używając przełącznika `use_synth`.


## Odkrywanie Syntezatorów

Aby zobaczyć, jakie syntezatory Sonic Pi ma dla Ciebie do zabawy, zerknij na zakładkę Syntezatory w lewym dolnym rogu (pomiędzy Przykładami a Efektami). Znajdziesz ich tam ponad 20 do wyboru. Oto kilka moich ulubionych:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Teraz pobaw się, *zmieniając syntezatory, gdy Twoja muzyka wciąż gra*. Próbuj rozerwać się, łącząc ze sobą różne dźwięki, aby tworzyć nowe brzmienia, jak również używając różnych syntezatorów w różnych sekcjach Twojego utworu.
