3.6 Sample Zewnętrzne

# Sample Zewnętrzne

Podczas gdy wbudowane sample pomogą Ci zacząć dość szybko, być może chciałbyś poeksperymentować z innymi nagraniami, które posiadasz w swojej bibliotece muzycznej. Sonic Pi całkowicie to wspiera. Zanim jednak pokażemy, jak można tego dokonać, przeprowadźmy krótką dyskusję dotyczącą przenośności Twoich utworów.

## Przenośność

Kiedy komponujesz swoje utwory, opierając się tylko i wyłącznie na wbudowanych syntezatorach i samplach, kod to jedyna rzecz, która jest niezbędna, aby wiernie odtworzyć Twoją muzykę. Pomyśl o tym przez chwilę - to jest niesamowite! Prosty kawałek tekstu, który możesz wysłać pocztą lub trzymać jako [Gist](https://gist.github.com), przedstawia wszystko, czego potrzebujesz, aby odtworzyć Twoje kawałki. Takie podejście sprawia, że *dzielenie się tą muzyką z Twoimi znajomymi jest naprawdę proste*, gdyż jedyne, co muszą zrobić, to zdobyć kod.

Jednakże gdy zaczniesz używać swoich własnych sampli, stracisz tę przenośność. Stanie się tak dlatego, gdyż do odtworzenia Twojej muzyki inni ludzie będą potrzebować nie tylko Twojego kodu - będą potrzebować również Twoich sampli. Takie podejście ogranicza innymi możliwość manipulowania, zmieniania i eksperymentowania z Twoją pracą. Oczywiście nie powinno to powstrzymać Cię od używania własnych sampli - to tylko coś, co musisz wziąć pod uwagę, gdy się na to zdecydujesz.

## Sample Lokalne

W jaki sposób możesz więc zagrać dowolny plik WAV, AIFF, OGG, OGA albo FLAC, znajdujący się na Twoim komputerze? Jedyne, co musisz zrobić, to przekazać jego ścieżkę do polecenia `sample`:

```
# Raspberry Pi, Mac, Linux
sample "/Users/sam/Desktop/my-sound.wav"
# Windows
sample "C:/Users/sam/Desktop/my-sound.wav"
```

Sonic Pi automatycznie załaduje i zagra wybrany sampel. Możesz również przekazać wszystkie standardowe parametry, które do tej pory przekazywałeś do polecenia `sample`:

```
# Raspberry Pi, Mac, Linux
sample "/Users/sam/Desktop/my-sound.wav", rate: 0.5, amp: 0.3
# Windows
sample "C:/Users/sam/Desktop/my-sound.wav", rate: 0.5, amp: 0.3
```

