2.2 Opções de Sintetizador

# Opções de Sintetizador: Amp (amplitude) and Pan (panorâmica)

Da mesma forma que te permite controlar qual nota tocar ou qual amostra disparar, o Sonic Pi fornece uma gama de opções para trabalhar e controlar os sons. Nós cobriremos muitas delas neste tutorial e há uma documentação extensa para cada um delas no sistema de ajuda. Entretanto, por hora vamos introduzir duas das mais úteis: *amplitude* e *pan*. Mas vamos ver primeiro o que realmente são 'opções'.


## Opções

O Sonic Pi suporta a notação de opções (ou opts, abreviando) para seus sintetizadores. Opções são controles você passa ao comando `play` que modificam e controlam aspectos do som que você ouve. Cada sintetizador tem seu próprio conjunto de opções para um ajuste fino do som. No entanto, existem algumas opções comuns compartilhadas por vários synths, tais como `amp:` e opções de *envelope* (cobertas em outra seção).

As opções possuem duas partes principais, seu nome (o nome do controle) e seu valor (o valor que você quer dar a este controle). Por exemplo, você pode ter uma opção chamada `queijo:` e quer dar a ela o valor `1`.

As opções são passadas ao comando `play` através do uso da vírgula `,` seguida do nome da opção `amp:` (não esqueça dos dois-pontos `:`) e então um espaço seguido do valor da opção. Por exemplo:

```
play 50, queijo: 1
```

(Note que `queijo:` não é uma opção válida, nós só estamos usando como exemplo).

Você pode passar múltiplas opções, separando-as com vírgulas:

```
play 50, queijo: 1, feijões: 0.5
```

A ordem das opções não importa, então estes casos são idênticos:

```
play 50, feijões: 0.5, queijo: 1
```

Opções que não forem reconhecidas pelo sintetizador serão simplesmente ignoradas (como `queijo` e `feijões`, que são claramente nomes de opções ridículos!)

Se, por acidente, você usar a mesma opção duas vezes com valores diferentes, a segunda vence. Por exemplo, `beans:` aqui você terá o valor 2 em vez de 0.5:

```
play 50, feijões: 0.5, queijo: 3, ovos: 0.1, feijões: 2
```

Muitas coisas no Sonic Pi aceitam opções, então gaste um pouco de tempo aprendendo como usá-las e você estará pronto! Vamos brincar com a nossa primeira opção: `amp:`.

## Amplitude

Amplitude é uma representação do volume de um som. Uma *grande amplitude produz um som barulhento* e uma *baixa amplitude produz um som quieto*. Da mesma forma que o Sonic Pi usa números para representar tempos e notas, ele usa números para representar amplitudes. Uma amplitude 0 é silêncio (você não ouvirá nada) enquanto uma amplitude igual a 1 é o volume normal. Você pode até estourar a amplitude para valores 2, 10, 100. Entretanto você deve notar que quando a amplitude geral, de todos os sons, fica muito alta, o Sonic Pi usa o que é chamado de compressor para espremer as amplitudes e garantir que as coisas não fiquem muito altas para seus ouvidos. Isto pode muitas vezes fazer o som ficar embolado e estranho. Então tente usar amplitudes baixas, isto é: na faixa entre 0 e 1 para evitar compressão.


## Amplificando

Para mudar a amplitude de um som, você pode usar a opção `amp:`. Por exemplo, para tocar com a metade da amplitude passe o valor `0.5`:

```
play 60, amp: 0.5
```

Para tocar com o dobro da amplitude, passe 2:

```
play 60, amp: 2
```

A opção `amp:` somente modifica a chamada para o `play`ao qual está associada. Então, neste exemplo, a primeira chamada toca a nota com a metade do volume e na segunda o volume volta para o padrão (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Sendo assim, você pode usar valores diferentes de `amp:` em cada comando `play`:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Controlando o Pan

Outra opção divertida para usar é  `pan:` que controla o som estéreo de lado-a-lado. Virar o som para a esquerda (pan left), significa que você ouvirá o som no alto-falante esquerdo, e virando para a direita (pan right), significa que você ouvirá o som no alto-falante direito. Usamos -1 para representar totalmente à esquerda, 0 para representar o centro e 1 para representar totalmente à direita, no campo estéreo. Sinta-se livre para usar qualquer valor entre -1 e 1 para controlar a posição exata do seu som.

Vamos tocar um bip no alto-falante esquerdo:

```
play 60, pan: -1
```

Agora vamos tocá-lo no alto-falante direito:

```
play 60, pan: 1
```

Finalmente, vamos tocá-lo de volta no centro (a posição padrão):

```
play 60, pan: 0
```

Agora, vá e divirta-se mudando a amplitude e a posição dos seus sons!
