8.2 Acordes

# Acordes

O Sonic Pi possui suporte para nomes de acordes que devolverão listas. Tente você mesmo:

```
play chord(:E3, :minor)
```

Agora estamos chegando em algum lugar. Isso parece muito mais bonito que listas brutas (e são mais fáceis de ler para outras pessoas). Então quais outros acordes o Sonic Pi suporta? Bem, *muitos*. Tente alguns destes:

* `chord(:E3, :m7)`
* `chord(:E3, :minor)`
* `chord(:E3, :dim7)`
* `chord(:E3, :dom7)`

## Arpejos

Podemos facilmente transformar acordes em arpejos com a função `play_pattern`:

```
play_pattern chord(:E3, :m7)
```

Ok, that's not so fun - it played it really slowly. `play_pattern` will play each note in the list with a call to `sleep 1` after each call to `play`. We can use another function `play_pattern_timed` to specify our own timings and speed things up:

```
play_pattern_timed chord(:E3, :m7), 0.25
```

Podemos até passar uma lista de tempos que serão tratados como um circulo de tempos:

```
play_pattern_timed chord(:E3, :m13), [0.25, 0.5]
```

Isto é equivalente a:

```
play 52, sustain: 0.25
sleep 0.25
play 55, sustain: 0.5
sleep 0.5
play 59, sustain: 0.25
sleep 0.25
play 62, sustain: 0.5
sleep 0.5
play 66, sustain: 0.25
sleep 0.25
play 69, sustain: 0.5
sleep 0.5
play 73, sustain: 0.25
sleep 0.25
```

Qual você prefere escrever?

Note that `play_pattern` and `play_pattern_timed` alter the sustain of the notes to fill the times. You can remove this behavior by setting the `sustain:` opt to `0`:

```
play_pattern_timed chord(:E3, :m13), [0.25, 0.5], sustain: 0
```
