2.2 Opções do Sintetizador

# Opções do Sintetizador: Amplitude and Panorâmica

Além de te permitir controlar que nota tocar ou qual o sample a tocar, o Sonic Pi dispõe de um conjunto de opções para criar e controlar os sons. Vamos cobrir algumas destas neste tutorial verifica que existe documentação detalhada para cada uma no sistema de ajuda. No entanto, para já vamos introduzir dois dos parâmetros mais úteis: *amplitude* e *panorâmica*. Primeiro, vamos ver quais são as nossas opções.


## Opções

O Sonic Pi suporta a notação de opções (ou opts, abreviando) para os sintetizadores. Opts são controlos que podes passar ao `play` que modificam e controlam aspectos do som que ouves. Cada sintetizador tem as suas próprias opts para afinar o seu som. No entanto, existem conjuntos de opts comuns partilhados por muitos synths tal como `amp:` e opts *envelope* (para serem faladas noutra secção).

Opts têm duas partes principais, o seu nome (o nome do controlo) e o seu valor (o valor que queres dar a essa opt). Por exemplo, podes ter uma opt chamada `queijo` e dar-lhe um valor de `1`.

Opts são passadas a comandos `play` ao usar uma virgula (`,`) e depois o nome da opt, como `amp:` (não te esqueças dos dois pontos `:`) e depois um espaço e o valor da opt. Por exemplo:

```
play 50, queijo: 1
```

(Nota que `queijo:` não existe mesmo, só estamos a usar como exemplo)

Podes dar várias opts separando-as por vírgulas:

```
play 50, queijo: 1, feijões: 0.5
```

A ordem das opts não interessa, por isso o seguinte é idêntico:

```
play 50, beans: 0.5, cheese: 1
```

Opts que não são reconhecidas pelo sintetizado são simplesmente ignoradas (como `queijo` e `feijões`, que são claramente nomes ridículos para opts!)

Se usares a mesma opt mais de uma vez com valores diferentes, a última ganha. Por exemplo, `feijões:` vai ter o valor `2` em vez de `0.5`:

```
play 50, feijões: 0.5, queijo: 3, ovos: 0.1, feijões: 2
```

Muitas coisas no Sonic Pi aceitam opts, portanto gasta algum tempo a aprender como usá-las e estarás preparado! Vamos brincar com a nossa primeira opt: `amp:`.

## Amplitude

A amplitude é a representação numcomputador do volume de um som. Um nível mais elevador de amplitude conduz a um som com um nível de pressão sonora mais elevado, e consequentemente mais alto e uma amplitude baixa produz um som com um nível de pressão sonora mais baixo, e consequentemente mais suave. Da mesma forma que o Sonic Pi usa números para representar tempo e notas, também usa números para representar amplitude. Uma amplitude de 0 é silenciosa (não vais ouvir nada) enquanto uma amplitude 1 é de volume normal. Até podes aumentar a amplitude para 2, 10, 100 ou mais. No entanto, deve-se notar que quando a amplitude de todos os sons aumenta demasiado, o Sonic Pi usa uma coisa chamada compressor que os baixa para ter a certeza que o som não está demasiado alto para os teus ouvidos. Isto pode fazer o som ficar turvo e estrano. Por isso tenta usar amplitudes baixas, entre 0 e 0.5 para evitar compressão.


## Aumenta o volume

Para mudar a amplitude de um som, podes usar a opt `amp:`. Por exemplo, para tocar com metade do nível de pressão sonora dá-lhe o valor `0.5`:

```
play 60, amp: 0.5
```

Para tocar com o dobro da pressão sonora, e consequentemente amplitude e intensidade, dá-lhe `2`:

```
play 60, amp: 2
```

A opt `amp:` só modifica a amplitude do `play` com que está associada. Então, neste exemplo, o primeiro `play` está a metade do volume e o segundo está no normal (`1`):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Claro, podes usar diferentes valores de `amp:` para cada `play`:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Panorâmica

Outra opt divertida é a `pan:`, que controla o a panorâmica de um som stereo. Usar *panning* para a esquerda num som significa que só o vais ouvir pela coluna esquerda, e usar *panning* para a direita significa que que só o vais ouvir pela coluna da direita. Como valores, usamos `-1` para representar a esquerda, `0 ` para o centro e `1` para a direita, em stereo. Claro, estamos livres para usar qualquer valor entre `-1` e `1` para controlar a posição exacta do som.

Vamos tocar um beep na coluna esquerda:

```
play 60, pan: -1
```

Agora, vamos tocar um beep na coluna direita:

```
play 60, pan: 1
```

Finalmente vamos tocar um beep no centro (posição predefinida):

```
play 60, pan: 0
```

Agora, diverte-te a mudar a amplitude e *panning* dos teus sons!
