5.1 Blocos

# Blocos

Uma estrutura que se vê bastante no Sonic Pi é um bloco. Um bloco permite-nos fazer coisas úteis com grandes pedaços de código. Podemos mudar algo que ocorre numa única linha de código com parâmetros de synth e sample. No entanto podemos querer fazer algo mais significativo a várias linhas de código. Por exemplo, podemos querer fazer um loop, adicionar reverb, apenas correr 1 vez a cada 5 vezes, etc. Considera o seguinte código:

```
play 50
sleep 0.5
sample :elec_plip
sleep 0.5
play 62
```

Para fazer algo com um pedaço de código devemos dizer ao Sonic Pi onde o bloco *começa* e onde *acaba*. Usamos `do` para o começo e `end` para o fim. Por exemplo:

```
do
  play 50
  sleep 0.5
  sample :elec_plip
  sleep 0.5
  play 62
end
```

No entanto isto não está completo e não funcionará (tenta e terás um erro) uma vez que não dissemos ao Sonic Pi o que fazer com este *bloco do/end*. Dizemos isso aos Sonic Pi escrevendo um código especial antes do `do`. Iremos ver alguns destes pedaços especiais de código mais tarde neste tutorial. Por agora, é importante saber que envolvendo o teu código entre `do`e `end` diz ao Sonic Pi que queres fazer algo especial com esse pedaço de código.
