A.16 Cum sa exersezi programarea live

# 8 Sfaturi pentru a exersa programarea live

Luna trecuta am aruncat o privire asupra a cinci tehnici importante pentru a stapani programarea live - cu alte cuvinte, am explorat cum am putea folosi Sonic Pi pentru a aborda programarea asa cum abordam un instrument muzical. Unul dintre cele mai importante concepte pe care le-am discutat a fost exersarea. Luna aceasta vom vedea mai in amanunt de ce este importanta exersarea in programarea live si cum ai putea incepe.


## Exerseaza regulat

Cel mai important sfat este sa te asiguri ca exersezi regulat. De regula eu exersez cam 1-2 ore pe zi, dar 20 de minute sunt de ajuns pentru inceput. Putin si des ar trebui sa fie ceea ce urmaresti la inceput - deci daca nu reusesti decat 10 minute, este un inceput bun.

Sfatul nr 1 - incepe sa-ti creezi un program pentru exersare. Gaseste o ora din zi care iti convine si incearca sa exersezi cat de multe zile poti la acea ora. Dupa un timp vei ajunge sa astepti cu nerabdare sesiunea de practica programata.


## Invata sa tastezi in orb

Daca privesti un muzician profesionist interpretand pe scena vei observa probabil cateva lucruri. In primul rand, cand canta el nu se uita la instrument. Degetele lui, bratele si corpul stiu pe ce clapa sa apese, ce coarda sa ciupeasca sau ce toba sa loveasca, fara ca ei sa trebuiasca sa se gandeasca la asta prea mult. Aceasta este cunoscuta drept "memoria muschilor" si desi suna ca un lucru pe care doar profesionistii il pot face - este acelasi lucru ca atunci cand ati invatat sa mergeti pe jos sau pe bicicleta - exersarea prin repetitie. Programatorii live folosesc memoria muschilor pentru a-si elibera mintea de nevoia de a se gandi unde sa isi miste degetele, astfel incat se pot concentra asupra muzicii. Aceasta se numeste tastare in orb - apasarea tastelor fara a fi nevoit sa privesti la tastatura.

Sfatul nr 2 - invata sa tastezi in orb. Exista multe aplicatii, site-uri web sau chiar jocuri care te pot ajuta sa faci asta. Gaseste ceva care iti place si insista pana cand poti sa scrii cod fara sa te uiti la tastatura.


## Programeaza in picioare

Corpul unui muzician este adaptat pentru interpretarea la instrumentul pe care si l-a ales. De exemplu, un trompetist trebuie sa poata sufla puternic, un chitarist trebuie sa poata tine griful cu putere iar tobosarul trebuie sa poata lovi in continuu tobele pentru perioade lungi de timp. Dar unde este partea fizica in programarea live? La fel ca un DJ, un programator live de obicei interpreteaza in timp ce sta in picioare, uneori chiar dansand in timp ce scrie cod! Daca exersezi programarea live in timp ce stai asezat in fata biroului si apoi vei fi nevoit sa stai in picioare pentru o interpretare in fata audientei, schimbarea pozitiei ti se va parea dificila si frustranta.

Sfatul nr 3 - stai in picioare cand exersezi. Cel mai usor este sa folosesti un birou mai inalt la care se poate lucra in picioare. Daca nu ai unul acasa (cum este si cazul meu), exista cateva optiuni la indemana. Eu folosesc o masa de calcat care se potriveste destul de bine. Alta varianta ar fi sa pui niste carti sau cutii sub tastatura ca sa ajunga la inaltimea potrivita. Ai grija sa faci cateva miscari de incalzire inainte sa incepi sa exersezi si incearca sa dansezi putin in timpul sesiunii. Tine minte, nimeni nu te priveste, deci poti sa te distrezi si te vei simti mult mai natural pe scena.


## Exerseaza pregatirea echipamentelor

Majoritatea instrumentelor muzicale necesita o parte de asamblare si reglaje inainte sa poti canta la ele. Daca nu esti cumva un star rock cu un autocar plin de tehnicieni dupa tine, va trebui sa iti pregatesti singur instrumentul inainte de interpretare. Adesea asta reprezinta o parte stresanta si care poate crea probleme. Un mod de a te pregati pentru acest lucru este sa incluzi partea de pregatire a echipamentelor in programul de exersare.

Sfatul nr 4 - trateaza pregatirea echipamentelor ca pe o parte importanta a exersarii. De exemplu, alege o cutie sau o geanta in care poti tine Raspberry Pi, tastatura si ce iti mai este necesar. Inainte de fiecare sesiune de repetitii, scoate componentele, conecteaza-le si porneste totul pana cand vezi Sonic Pi pe ecran, pregatit sa scoata sunete. Dupa ce termini repetitia, impacheteaza totul cu grija la loc. Aceasta iti va lua ceva timp la inceput, dar in curand vei fi capabil sa pui totul in functiune sau sa impachetezi foarte rapid, fara sa te mai gandesti cum se face asta.


## Experimenteaza

Odata ce totul este pregatit si poti incepe sa creezi muzica, s-ar putea sa nu stii de unde sa incepi. O problema care apare adesea este ca poti sa stii cam ce sunete vrei sa produci, dar esti frustrat fiindca nu stii cum anume sa faci asta. Uneori s-ar putea chiar sa nu stii nici ce sunete vrei sa produci! Cel mai important este sa nu te ingrijorezi - acest lucru se intampla oricarui muzician - chiar daca exerseaza de mult timp. Este mult mai bine sa creezi sunete care nu iti plac decat sa nu creezi nimic.

Sfatul nr 5 - petrece suficient timp creand sunete si muzica chiar daca sunt nereusite. Fa-ti timp sa explorezi noi sunete si idei. Nu te ingrijora ca ar putea suna groaznic sau nu ar fi stilul pe care il cauti. Cand experimentezi in felul asta cresc sansele de a da peste un sunet sau o combinatie de sunete de care te vei indragosti!  Chiar daca 99% dintre sunetele pe care le produci sunt aiurea, restul de 1% ar putea fi exact riff-ul sau introducerea pentru o noua piesa. Uita ce nu ti-a placut si retine doar restul. Acest lucru este foarte usor cand faci muzica folosind programarea - doar apesi pe 'Save'!


## Asculta codul

Multi muzicieni pot privi o partitura si sa "auda" muzica fara a fi nevoiti sa o cante. Aceasta abilitate este foarte utila si merita sa o folositi cand exersati programarea live. Este important sa intelegeti macar partial cum va suna bucata de cod. Nu e nevoie sa fiti capabili sa o auziti exact, dar e bine sa stiti macar daca va fi o bucata rapida, lenta, zgomotoasa, ritmica, melodica, aleatoare, etc. Scopul final este sa puteti reversa procesul - sa imaginati muzica in minte si sa stiti cum sa scrieti codul care o va crea. Acest lucru poate lua mult timp, dar odata ce veti stapani procesul, veti putea improviza pe scena ca sa va exprimati fluent ideile.

Sfatul nr 6 - scrie o bucata de cod in Sonic Pi si nu apasa pe 'Run'. Incearca sa iti imaginezi ce sunet va produce. Apoi, apasa 'Run', asculta si gandeste-te ce s-a potrivit si ce nu cu ce ti-ai imaginat. Repeta acest exercitiu pana cand va deveni o parte naturala a modului tau de a programa. Cand repet am in mod normal o idee destul de clara despre cum va suna. Totusi, uneori poti fi surprins si atunci ma opresc si ma gandesc de ce suna altfel decat mi-am imaginat. De fiecare data cand se intampla acest lucru, invat noi trucuri care imi permit sa ma exprim muzical in noi moduri.

## Inlatura orice te poate distrage

O problema uzuala cand exersezi este sa fii distras de alte lucruri. Sa exersezi este dificil si necesita disciplina indiferent ce fel de muzica creezi - ca este jazz sau clasica sau dance. Daca nu reusesti sa faci progrese in timpul repetitiei e foarte usor sa treci rapid la social media sau sa cauti ceva pe Internet. Daca ti-ai propus insa sa repeti 20 de minute, e important sa respecti acest lucru si sa petreci tot acest timp fiind cat poti de productiv.

Sfatul nr 7 - inainte de a incepe sa repeti inlatura tot ce te poate distrage. De exemplu, deconecteaza-te de la Internet, du-ti telefonul in alta camera si incearca sa exersezi intr-un loc linistit unde este putin probabil sa fii deranjat. Incearca sa te concentrezi pe crearea de muzica si te vei putea intoarce la celelalte lucruri cand termini.


## Tine un jurnal al repetitiilor

Cand exersezi mintea ta poate fi inundata de idei noi si incitante - noi directii muzicale, noi sunete pe care sa le incerci, functii noi pe care sa le scrii etc. Aceste idei sunt adesea atat de interesante incat ai putea sa te opresti din ce faci ca sa incepi sa lucrezi la ceva nou. Aceasta este alta forma de a fi distras!

Sfatul nr 8 - tine un jurnal al repetitiilor langa tastatura. Cand ai o idee noua si interesanta, fa o pauza, noteaza-ti rapid ideea pe hartie, apoi continua cu ceea ce faceai. Vei putea sa te gandesti pe indelete si sa lucrezi la acea idee dupa ce termini de exersat.


## Sa punem totul cap la cap

Incearca sa iti stabilesti un program de repetitii care sa includa cat mai multe dintre aceste idei. Fa sesiunile cat se poate de placute, dar fii constient ca unele dintre ele vor fi dificile si vei simti ca ai de muncit. Dar iti vei da seama ca a meritat cand vei produce prima ta piesa sau vei sustine prima interpretare live. Tine mine, repetitia este cheia succesului!
