1.2 Обзор интерфейса

# Интерфейс Sonic Pi

У Sonic Pi очень простой интерфейс для кодирования музыки. Мы потратим совсем немного времени на его изучение.

![Интерфейс Sonic Pi](../../../etc/doc/images/tutorial/GUI.png)


* *A* - Управление воспроизведением
* *B* - Управление редактором
* *C* - Помощь и справка
* *D* - Редактор кода
* *E* - Панель настроек
* *F* - Просмотр сообщений
* *G* - Справочная система
* *F* - Просмотр сообщений
* *F* - Просмотр сообщений

## A. Управление Воспроизведением

Эти розовые кнопки - главные элементы для запуска и остановки звука. Есть кнопка *Выполнить* для запуска кода из редактора, *Остановить* для остановки всего выполняющегося кода, *Сохранить* для сохранения кода в файл и *Запись* для создания записи того, что вы слышите в звуковой файл в формате WAV.

## B. Управление Редактором

Эти оранжевые кнопки позволяют управлять редактором кода. Кнопки *Size +* и *Size -* позволяют сделать текст больше и меньше.

## C. Помощь И Справка

Данные синие кнопки дают вам доступ к информации и настройкам. Кнопка *Информация* открывает справочное окно, в котором находится информация о самом Sonic Pi - главной команде разработчиков, истории, помощниках и сообществе. Кнопка *Помощь* включает систему помощи (*F*), а кнопка *Параметры* включает панель настроек, где можно менять некоторые базовые параметры приложения.

## D. Редактор Кода

Это область, в которой вы будете писать свой код и сочинять/исполнять музыку. Это простой текстовый редактор, где можно написать код, удалить его, вырезать, вставить и так далее. Представьте, что это простая версия Word или Google Docs. Редактор автоматически раскрасит слова в зависимости от их значения в коде. Поначалу это может казаться странным, но скоро вы увидите, насколько это помогает. К примеру, глядя на что-то синее ты будешь знать, что это число.

## E. Панель Настроек

В Sonic Pi есть множество настраиваемых параметров. Доступ к ним можно получить, нажав кнопку *Параметры* в наборе кнопок "Помощь и справка". Она переключит видимость панели настроек, в которой представлено множество вариантов, доступных для изменения. Примерами являются режим моно, инвертированное стерео, включение вывода детальных сообщений, ползунок громкости и выбор аудиовыхода Raspberry Pi.

## F. Просмотр Сообщений

Когда твой код выполняется, информация о том, что делает программа, будет выводиться в лог сообщений. По умолчанию, ты будешь видеть новое сообщение для каждого воспроизводимого звука с точным указанием времени, когда он начался. Это очень полезно для отладки кода и понимания того, что он делает.

## G. Справочная Система

Наконец, одна из самых важных частей интерфейса Sonic Pi - это справочная система, которую можно увидеть в нижней части окна приложения. Её можно выводить и прятать, нажимая синюю кнопку *Помощь*. В справочную систему входит помощь и информация обо все аспектах Sonic Pi, включая этот учебник, список доступных синтезаторов, сэмплов, эффектов, примеры и полный перечень всех функций Sonic Pi для кодирования музыки.

## H. Область видимости

В области видимости можно наблюдать за воспроизводимым звуком. Вы с лёгкостью заметите, что пилообразная волна действительно напоминает пилу, а простейшие сигналы выглядят как синусоидальные волны. Вы также можете увидеть разницу между громкими и тихими звуками, глядя на размер выводимых линий. Существует три области видимости, с которыми можно повозиться - стандартная (комбинация левого и правого каналов), стерео (каждый канал обособлен) и, наконец, область видимости фигур Лиссажу, которая показывает отношения фаз левого и правого каналов, а также позволяет создавать красивые изображения при помощи звука. [Фигуры Лиссажу](https://ru.wikipedia.org/wiki/%D0%A4%D0%B8%D0%B3%D1%83%D1%80%D1%8B_%D0%9B%D0%B8%D1%81%D1%81%D0%B0%D0%B6%D1%83).

## F. Просмотр Сообщений

Все внутренние и внешние события (в Sonic Pi они называются cues) автоматически регистрируются в Cue Viewer. Например, если вы подключили MIDI-контроллер и нажали одну из его кнопок, в Cue Viewer появится новое событие cue, сообщающее вам название контроллера и то, какую кнопку вы нажали. Когда вы освоите основы создания и воспроизведения звуков, вам захочется создавать звуки или целые секции звуков на основе таких событий, как эти. Событие подсказки – это просто указание на то, что что-то произошло. Например, каждый раз, когда live_loop совершает цикл, оно посылает событие cue, которое регистрируется в Cue Viewer. Кроме того, внешние события, такие как MIDI-сообщения от подключенного MIDI-оборудования и OSC-сообщения от других программ или компьютеров, также отображаются в Cue Viewer. Также можно напрямую генерировать события cue с помощью функции `cue`. Всё, что появляется в Cue Viewer, может быть использовано для запуска какого-либо события. Более подробно об этом рассказывается в разделах 10-12 данного руководства.
