1.1 Canlı Kodlama

# Canlı Kodlama

Sonic Pi'nin en heyecan verici yönlerinden biri, tıpkı bir gitarla canlı performans sergileyebileceğiniz gibi, müzik yapmak için kodu yazmanıza ve * canlı olarak değiştirmenize * olanak vermesidir. Bu, biraz pratik yaptıktan sonra Sonic Pi'yi sahneye alıp onunla birlikte çalışabileceğiniz anlamına gelir.

## Aklını boşalt

Bu eğitimin geri kalanında Sonic Pi'nin nasıl çalıştığına dair gerçek ayrıntılara girmeden önce, size kodlamanın tadını çıkarmanın nasıl olduğunun bir pratiğini vermek isterim. Bunu (veya herhangi birini) pek anlamadıysanız endişelenmeyin. Sadece koltuklarınıza oturun ve ...

## Bir canlı döngü

Hadi başlayalım, takip eden kodu boş bir kanala kopyala:

```
live_loop :flibble do
  sample :bd_haus, rate: 1
  sleep 0.5
end
```

Şimdi, `Çalıştır` düğmesine basın ve güzel, hızlı bir bas davulunun çaldığını duyacaksınız. Herhangi bir anda sesi durdurmak isterseniz, sadece `Durdur` düğmesine basın. Henüz vurmasa da ... Bunun yerine şu adımları izleyin:

1. Bas davul sesinin hala çalıştığından emin olun
2. `Uyku` değerini `0,5` ten `1` gibi daha yüksek bir değerle değiştirin.
3. Tekrar `Çalıştır` düğmesine basın
4. Davul sesinin hızının nasıl değiştiğine dikkat edin.
5. Son olarak, * bu anı hatırla *, bu, Sonic Pi ile canlı kodlanmış olarak yaşadığın ilk an ve muhtemelen sonuncusu olmayacak ...

Evet, bu yeterince kolaydı. Şimdi de düzenlemeye yeni bir şeyler ekleyelim. `sample:bd_haus` satrının hemen üstüne `sample:ambi_choir,rate:0.3` satırını ekleyelim. Kodunuz şöyle görünmeli:

```
live_loop :flibble do
  sample :ambi_choir, rate: 0.3
  sample :bd_haus, rate: 1
  sleep 1
end
```

Şimdi oynatalım. Şimdi ayarları biraz değiştirelim - yüksek değeler kullandığınızda ne oluyor veya küçük değerler veya negatif değerler? `:ambi_choir` örneği için `rate:` değerini bir parça (örneğin `0.29`) değiştirdiğinizde ne olduğuna bakın. `sleep`değeri için çok küçük bir değer seçtiğinizde ne oluyor? Bunu çok hızlandırdığınızda bilgisayarınızın hata verip durduğunu göreceksiniz çünkü bu işlemi daha fazla yapamaz (eğer böyle olursa, `sleep` değeri için daha büyük bir değer seçip `Run`komutunu tekrar çalıştırın).

`sample` satırlarından birisini satır başına `#` karakteri ekleyerek yorum yapmayı deneyin:

```
live_loop :flibble do
  sample :ambi_choir, rate: 0.3
#  sample :bd_haus, rate: 1
  sleep 1
end
```

Bilgisayarın bu satırı görmezden gelmesini söylediğine ve bu satırı duymadığınızı göreceksiniz. Bu satır yorum satırı olarak adlandırılır. Sonic Pi'da düzenlemedeki bazı satırları kaldırmak için yorum satırına dönüştürebiliriz veya yorum satırı olan satırları düzenlemeye eklemek için yorum satırı olmaktan çıkarabiliriz.

Son olarak, size eğlenmeniz için bir şeyler bırakmama izin verin. Aşağıdaki kodu kopyalarak boş bir buffer'a alın. Şimdilik kodu anlamaya çalışmayın ancak iki döngü olduğuna dikkat edin, yani iki döngü aynı anda çalışacak. Şimdi kendinize zaman ayırın ve deneyerek yapabileceğinizin en iyisini yapmaya çalışın. Sizin için bazı tavsiyeler:

* Örnek sesin değiştiğini görmek için mavi `rate:` değerini değiştirmeyi deneyin.
* `sleep` sürelerini değiştirmeyi deneyin ve döngülerin farklı oranlarda çalındığını duyun.
* Örnek satırı yorum satırı olmaktan çıkarmayı deneyin (`#` işaretini silin) ve geriye doğru çalan gitarın sesinin tadını çıkarın.
* Herhangi bir mavi `mix:` değerini `0` (düzenleme içinde değil) ve `1` (tüm düzenleme içinde) değiştirmeyi deneyin.

Döngü bir daha döndüğünde değişiklikleri duymak için `Run`butonuna tıklamayı unutmayın. Eğer bir sorunla karşılaşırsanız endişelenmeyin ve `Stop`butonuna tıklayın, buffer'daki tüm kodu temizleyerek kodun temiz bir örneğini tekrar yapıştırın ve yeniden başlayın. En hızlı öğrenme yöntemi hata yapmaktır...


```
live_loop :guit do
  with_fx :echo, mix: 0.3, phase: 0.25 do
    sample :guit_em9, rate: 0.5
  end
#  sample :guit_em9, rate: -0.5
  sleep 8
end
live_loop :boom do
  with_fx :reverb, room: 1 do
    sample :bd_boom, amp: 10, rate: 1
  end
  sleep 8
end
```

Şimdi, bunun nasıl çalıştığı ile ilgili merakınızı giderene kadar ayarlarla oynamaya ve denemeler yapmaya devam edin ve başka neler yapabileceğinizi düşünmeye başlayın. Şimdi rehberin geri kalanını okumaya hazırsınız.

Öyleyse ne bekliyorsunuz...
